ATK_INTER
#ifndef _cltextview_H_
#define _cltextview_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 

#define cltextview_PREPROCESS 0
#define cltextview_POSTPROCESS 1


#include <textview.H>
 
	typedef void (*cltextview_hitfptr)(class ATK *observer, class cltextview *self, long *position, long *numClicks, enum view_MouseAction *act, long *startLeft, long *startRight, long *leftPos, long *rightPos, long rock, int prepost);

class cltextview : public  textview  {
public:
	virtual ATKregistryEntry *ATKregistry(); 
       void GetClickPosition(long position, long numberOfClicks, enum view_MouseAction action, long startLeft, long startRight, long *leftPos, long *rightPos);
       void FullUpdate(enum view_UpdateType type, long left, long top, long width, long height);

    
      virtual void AddClickObserver( ATK  * observer,
				    cltextview_hitfptr callBack, long rock );
      virtual void RemoveClickObserver( ATK  * observer );
      virtual void RemoveClick( ATK  * observer,
			       cltextview_hitfptr callBack );
    
      
	virtual ~cltextview();
      
	cltextview();
    
      short maxObservers;			/* number of entries in observers table */
      struct cltextview_observer *observers;	/* table of observers */
      class cursor *cursor;
};

struct cltextview_observer
{
  ATK  * observer;
  cltextview_hitfptr callBack;
  long rock;
};

#endif /* _cltextview_H_ */
