#ifndef _ctext_H_
#define _ctext_H_
/* File ctext.H created by R L Quinn
   (c) Copyright IBM Corp.  1988-1995.  All rights reserved.

$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $

   ctext: a text subclass specialized for dealing with C code. */

/* kinds of styles that are used in hash table */
#define KEYWRD 1     /* keywords */
#define PREPRC 2     /* preprocessor directives */

#include "srctext.H"
class ctext: public srctext {
  public:
    virtual ATKregistryEntry *ATKregistry();

    int Indentation(long pos);
    boolean IsTokenChar(char ch);
    boolean Quoted(long pos);
    void RedoStyles();
    void SetAttributes(struct attributes *atts);
    void SetupStyles();

    virtual long BackwardSkipDelimited(long pos, char begin, char end);
    virtual long BackwardSkipJunk(long pos);
    virtual long CheckPreproc(long start);
    virtual long MaybeBackwardSkipCppLines(long pos);
    virtual long UnstyledCommentStart(long pos);

    static boolean InitializeClass();
    ctext();

    /* Variables used to control the indenting style. */
    int braceIndent, switchLabelUndent, switchLevelIndent;
    boolean outdentPreproc;
};

#endif /* _ctext_H_ */
